#include <stdio.h>

int main(int argc, char *argv[]) {
  char *filename;
  int f, i = 0;
  double x,y,z,r, p, p1, p2, sh;

  if(argc <= 5) exit(0);

  sscanf( argv[1], "%lf", &p1);
  sscanf( argv[2], "%lf", &p2);
  sscanf( argv[3], "%d", &f);
  sscanf( argv[4], "%lf", &sh);
  filename = argv[5];

  p1 *= p1;
  p2 *= p2;

  if(p1 > p2) exit(0);


  switch(f) {
  case 1:
    printf("# Selected (%lf <= r < %lf) && (value >= %lf) from %s.\n",
	   p1, p2, sh, argv[5]);
    break;
  case -1:
    printf("# Selected (%lf <= r < %lf) && (value <= %lf) from %s.\n",
	   p1, p2, sh, argv[5]);
    break;
  default:
    printf("# Selected (%lf <= r < %lf) && (|value| < %lf) from %s.\n",
	   p1, p2, sh, argv[5]);
    break;
  }

  while(scanf("%lf%lf%lf%lf\n", &x, &y, &z, &r) != EOF) {
    p = x*x + y*y + z*z;
    if((p >= p1) && (p < p2)) {
      switch(f) {
      case 1:
	if(r >= sh) {
	  printf("%lf\t%lf\t%lf\t%lf\n", x, y, z, r);
	  i++;
	}
	break;
      case -1:
	if(r <= sh) {
	  printf("%lf\t%lf\t%lf\t%lf\n", x, y, z, r);
	  i++;
	}
	break;
      default:
	if((-sh < r) && (r < sh)) {
	  printf("%lf\t%lf\t%lf\t%lf\n", x, y, z, r);
	  i++;
	}
	break;
      }
    }
  }
  printf("# number of data = %d\n", i);

}
