#!/usr/bin/perl

print "Content-type: image/jpeg\n\n";       #HTTP header

$|= 1;  # no buffering
$gpdata= "";

if ($ENV{'REQUEST_METHOD'} eq "POST"){
    read(STDIN, $form_data, $ENV{'CONTENT_LENGTH'});  # receive form data
}else{
    $form_data = $ENV{'QUERY_STRING'};
}

# decode URI encoded data *************************
@part = split('&', $form_data);
foreach $i (@part) {
    ($variable, $value) = split('=', $i);
    $value =~ tr/+/ /;
    $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
#    $value =~ s/\r\n/<BR>/g;  $value =~ s/[\r\n]/<BR>/g;
    $value =~ s/<BR>$//g;
    $fdata{$variable}=$value;
#    print "$fdata($variable)=$value\n";
}

$quality = $fdata{'quality'};
if     ($quality eq "preview"){
    $q_preview = "checked";
#    $povopt= "+W160 +H120";
    $waitmark="o"x20;
}elsif ($quality eq "320x240"){
    $q_320x240 = "checked";
    $povopt= "+W320 +H240 +A.1";
    $waitmark="o"x4;
}elsif ($quality eq "480x360"){
    $q_480x360 = "checked";
    $povopt= "+W480 +H360 +A.1";
    $waitmark="o"x2;
}elsif ($quality eq "640x480"){
    $q_640x480 = "checked";
    $povopt= "+W640 +H480 +A.1";
    $waitmark="o";
}elsif ($quality eq "1280x960"){
    $q_640x480 = "checked";
    $povopt= "+W1280 +H960 +A.1";
    $waitmark=".";
}else{  # default
    $q_preview = "checked";
#    $povopt= "+W160 +H120";
    $waitmark="o"x20;
}

$gpdata = $fdata{'gpdata'};

############################

#print($gpdata);
#print("\n\n++++++  START +++++++++\n");

open(OUT, "|perl gp2pov.pl | povray +I- +O- +FC +V $povopt | /usr/bin/X11/convert -quality 100 tga:- jpg:-");
print(OUT $gpdata);
close(OUT);

#print("\n\n++++++   END  +++++++++\n");

